/*
 * $Id: aochat.c,v 1.1.1.1 2003/04/17 14:14:36 pickett Exp $
 *
 * AOChat -- library for talking with the Anarchy Online chat servers
 * Copyright (c) 2003 Oskari Saarenmaa <pickett@sumu.org>.
 * All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 *
 *
 */


#include <assert.h>
#include <netdb.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <netinet/in.h>
#include <sys/socket.h>

#include "aochat.h"


aochat_t *
aoc_init()
{
  aochat_t *data;
  
  data = calloc(1, sizeof(*data));

  data->fd = -1;
  data->state = AOCS_UNCON;

  return data;
}

int
aoc_connect(char *server, int port, aochat_t *aoc)
{
  struct hostent  *hostent;
  struct sockaddr_in addr;
  int sock;
  
  assert(aoc != NULL);
  
  if(aoc->state != AOCS_UNCON &&
     aoc->state != AOCS_DISCONNECTED)
  {
    return -1;
  }
  
  if(server == NULL)
    server = strdup("chat2.d1.funcom.com");
  if(port == 0)
    port = 7012;

  hostent = gethostbyname(server);
  if(hostent == NULL || hostent->h_addrtype != AF_INET)
    return -1;
    
  addr.sin_family = AF_INET;
  memcpy(&(addr.sin_addr.s_addr), hostent->h_addr, hostent->h_length);
  addr.sin_port = htons(port);
  
  sock = socket(PF_INET, SOCK_STREAM, 0);
  if(sock == -1)
    return -1;
  
  if(connect(sock, (struct sockaddr *)&addr, sizeof(addr)) == -1)
    return -1;
 
  aoc->fd = sock;
  aoc->state = AOCS_CONNECTED;
  
  return sock;
}

void
aoc_read_data(aochat_t *aoc)
{
  (*aoc->cb)(0, NULL);
}
