/*
 * $Id: aochat.h,v 1.1.1.1 2003/04/17 14:14:36 pickett Exp $
 *
 * AOChat -- library for talking with the Anarchy Online chat servers
 * Copyright (c) 2002, 2003 Oskari Saarenmaa <pickett@sumu.org>.
 * All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 *
 *
 */


#ifndef _AOCHAT_H
#define _AOCHAT_H

/* Type definitions */
typedef struct aochat_s aochat_t;
typedef struct aochat_arg_s aochat_arg_t;
typedef void aoc_callback_t(int, aochat_arg_t *);
typedef enum aoc_state_e
{
  AOCS_UNCON = 0,
  AOCS_CONNECTED,
  AOCS_AUTHENTICATED,
  AOCS_LOGGEDIN,
  AOCS_DISCONNECTED
} aochat_state_t;

/* Data structures */
struct aochat_arg_s
{
  char   type;
  
  size_t intc;
  int   *intv;

  size_t charc;
  char **charv;
  
  aochat_arg_t *next; /* pointer to next argument in list */
};

struct aochat_s
{
  int fd;
  aochat_state_t state;
  aoc_callback_t *cb;
};


/* Function prototypes */
void aoc_read_data(aochat_t *);
void generate_login_key(char*, char*, char*, char**);

#endif
